<?php

class miepay {
    var $code, $title, $description, $enabled;

	function miepay() {
      global $order,$db;

      $this->code = 'miepay';
      $this->title = MODULE_PAYMENT_IEPAYM_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_IEPAYM_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_IEPAYM_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_IEPAYM_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_IEPAYM_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_IEPAYM_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();     
      $check_query =$db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_IEPAYM_KEY_URL'");      		
      $this->form_action_url = $check_query->fields['configuration_value']."/kmdcardfinance.php";
    }

	function update_status() {
      global $order,$db;

      if ( ($this->enabled == true) && (MODULE_PAYMENT_IEPAYM_ZONE > 0) ) {
        $check_flag = false;        
        $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_IEPAYM_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
  
        while (!$check->EOF)         
        {
          if ($check->fields['zone_id'] < 1) 
          {
            $check_flag = true;
            break;
          } 
          elseif ($check->fields['zone_id'] == $order->billing['zone_id']) 
          {
            $check_flag = true;
            break;
          }
          $check->MoveNext();
        } 
               
        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }
    
    function javascript_validation() {
      return false;
    }

    function selection() {
	  return array('id' => $this->code,
                   'module' => $this->title);
	}

    function pre_confirmation_check() {
      global $order;
	  if ( $order->info[total] < 0) {
		  $result = false ;
		  $error = 1 ;
		  $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
		  zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
	  } else {
		  $result = true ;
	  }
	  return $result ;
    }

    function confirmation() {
      return array('title' => MODULE_PAYMENT_IEPAYM_TEXT_CONFIRMATION);
    }

    function process_button() {
      global $order,$db ;
	  if ( $_SESSION['szen'] == "" ) {
			$_SESSION['szen'] = 1 ;
	  } else {
			$_SESSION['szen']++ ;
	  }
		$check_query =$db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_IEPAYM_DEALERCODE'");	  
	  $check = $check_query->fields['configuration_value'];	  
	  if (trim($check)=="") {
			  $DealerCode = "6" ;
			  $PassWord = "demo123" ;
	  } else {
			  $DealerCode = $check;
			  $check_query =$db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_IEPAYM_PASSWORD'");
			  $check = $check_query->fields['configuration_value'];			  
			  $PassWord = $check ;
			  if ($PassWord == "") {
					  $DealerCode = "6" ;
					  $PassWord = "demo123" ;
			  }
	  }
	  
	  $oid_query =$db->Execute("select count(orders_id) CNT from " . TABLE_ORDERS . " where DATE_FORMAT( date_purchased,  '%Y-%m-%d'  )  =  '".date("Y-m-d")."' and left(payment_method,4) = 'ePay'" );
	  $oid_array = $oid_query->fields['count(orders_id)'];
	 
	  $oid = date('dHis').substr((100+$oid_array[CNT]+1),1) ;
	  
      $process_button_string = zen_draw_hidden_field('storeid', $DealerCode) .
                               zen_draw_hidden_field('passwd', $PassWord) .
                               zen_draw_hidden_field('account', urlencode(round($order->info[total],2))) .
                               zen_draw_hidden_field('remark', urlencode($order->info['comments'])) .                              
                               zen_draw_hidden_field('orderid', $oid . "-" . substr(($_SESSION['szen']+100),1)) .
			       zen_draw_hidden_field('storename', urlencode(STORE_NAME)).
			       zen_draw_hidden_field('backurl', zen_href_link('checkout_process', '', 'SSL')) .
			       zen_draw_hidden_field('sessionid', zen_session_id());
      return $process_button_string;
	}

    function before_process() {
    global $db;
		$check = $_GET['checkcode'] ;
		if (strlen($check) == strlen($_GET['authcode']) and (int)$check <> 0 ) 
		{
			  $_SESSION['AUTHCODE'] = $_GET['authcode'] ;
			  $_SESSION['PAYMENTOID'] = $_GET['orderid'] ;
   	    $check_query =$db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_IEPAYM_KEY_URL'");	    
        $url = $check_query->fields['configuration_value'].'/cardstatus.php?authcode=' . md5(substr(( $check*$_GET['authcode']),0,10));
			  $result = implode("",file( $url ));

			  if(trim((string)zen_session_id()) === trim((string)$result)) 
			  {				
				  return true ;
			  } 
		    else 
		    {
				  	$error = 2 ;
					  $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
					  zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
			  }			
		 } 
		 else 
		 {
			$error = 2 ;
			$payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
			zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
		 }     
      return false;
    }

    function after_process() {
		global $insert_id,$db ;		  
		  $db->Execute("update ".TABLE_ORDERS." set cc_owner='".$_SESSION['AUTHCODE']."', cc_number ='".$_SESSION['PAYMENTOID']."' where orders_id='".(int)$insert_id ."'");
		  unset($_SESSION['AUTHCODE']);
		  unset($_SESSION['PAYMENTOID']);		
		  unset($_SESSION['step']) ;
      return true;
    }

    function get_error() {
	  switch ($_GET['error']) {
		  case 1 :
		  	$error_message = MODULE_PAYMENT_IEPAYM_TEXT_ERROR_1 ;
		  break ;
		  case 2 :
		  	$error_message = MODULE_PAYMENT_IEPAYM_TEXT_ERROR_2 ;
		  break ;
	  }
      $error = array('title' => MODULE_PAYMENT_IEPAYM_TEXT_ERROR,
                     'error' => $error_message );
      return $error;
    }

    function remove() {
    	global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_IEPAYM_STATUS', 'MODULE_PAYMENT_IEPAYM_ZONE', 'MODULE_PAYMENT_IEPAYM_ORDER_STATUS_ID',  'MODULE_PAYMENT_IEPAYM_DEALERCODE', 'MODULE_PAYMENT_IEPAYM_PASSWORD', 'MODULE_PAYMENT_IEPAYM_SORT_ORDER','MODULE_PAYMENT_IEPAYM_KEY_URL','MODULE_PAYMENT_IEPAYM_KEY_COMFIRM_URL');
    }

	function check() {
 	global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_IEPAYM_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {	 
	 global $language,$module_type,$db ;
	 if (!defined('MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_1_1')) include(DIR_FS_CATALOG_LANGUAGES . $language . '/modules/' . $module_type . '/' . $this->code . '.php');

    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ( '" . MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_1_1 . "',  'MODULE_PAYMENT_IEPAYM_STATUS', 'True', '" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_1_2. "', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now());");
	  $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_2_1. "', 'MODULE_PAYMENT_IEPAYM_ZONE', '0', '" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_2_2. "', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
	  $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_3_1. "', 'MODULE_PAYMENT_IEPAYM_ORDER_STATUS_ID', '0', '" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_3_2. "', '6', '3', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_4_1. "', 'MODULE_PAYMENT_IEPAYM_DEALERCODE', '', '" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_4_2. "', '6', '4', now());");
    $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_5_1. "', 'MODULE_PAYMENT_IEPAYM_PASSWORD', '', '" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_5_2. "', '6', '5', now());");
	  $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_0_1. "', 'MODULE_PAYMENT_IEPAYM_SORT_ORDER', '0', '" .MODULE_PAYMENT_IEPAYM_INSTALL_MESSAGE_0_2. "', '6', '0', now())");
	  $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" .MODULE_PAYMENT_IEPAYM_MESSAGE_URL. "', 'MODULE_PAYMENT_IEPAYM_KEY_URL','https://www.epay.cc/creditcard','".MODULE_PAYMENT_IEPAYM_DESC_URL."','6', '6', now());");
	  $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('" .MODULE_PAYMENT_IEPAYM_MESSAGE_COMFIRM_URL. "', 'MODULE_PAYMENT_IEPAYM_KEY_COMFIRM_URL','http://www.epay.cc','".MODULE_PAYMENT_IEPAYM_DESC_COMFIRM_URL."', '6', '7', now());");
  }
}
?>
